<template>
  <nav class="main">

    <div
      v-if="!isProductionEnvironment"
      class="not-prod-env"
    >
      <span
        v-if="isBetaEnvironment"
        title="adacraft beta version,
        with new experimental features"
      >
        beta
      </span>
      <span
        v-else
        title="You are using a dev, test, staging
        or beta environment for adacraft."
      >
        not the prod env
      </span>
    </div>

    <div class="app-logo-and-name">
      <img src="../assets/logo.svg" :alt="$t('general.adacraftLogo')" width="30">
      <router-link to="/" class="app-name"> adacraft </router-link>
    </div>


    <div class="nav-actions">

      <div class="md:flex-grow">
        <router-link to="/add-project" class="nav-action">
          {{ $t('navbar.menu.create') }}
        </router-link>
        <a
          class="nav-action"
          target="_blank" rel="noopener noreferrer"
          href="https://adacraft.notion.site/a97f3c21ccda49c9b1c8c3d74d415345"
          :title="$t('navbar.menu.title.featured')"
        >
          {{ $t('navbar.menu.featured') }}
        </a>
        <a
          class="nav-action"
          target="_blank" rel="noopener noreferrer"
          href="https://adacraft.notion.site/0da3831fbbe148dc9afe9c02fdf9c963"
          :title="$t('navbar.menu.title.documentation')"
        >
          {{ $t('navbar.menu.docs') }}
        </a>
        <a
          class="nav-action"
          target="_blank" rel="noopener noreferrer"
          href="https://adacraft.notion.site/9c3173376e2e47478573d6caa9e0e011"
        >
          {{ $t('navbar.menu.about') }}
        </a>
        <a
          class="nav-action"
          target="_blank" rel="noopener noreferrer"
          :href="feedbackUrl"
          :title="$t('navbar.menu.title.feedback')"
        >
          {{ $t('navbar.menu.feedback') }}
        </a>
      </div>

      <div class="pr-10">
        <button 
          @click="toggleDark()"
          class="darkmode-button"
          :title="$t('navbar.menu.title.darkMode')"
        >
          {{ isDark ? $t('navbar.menu.lightMode') : $t('navbar.menu.darkMode') }}
        </button>
      </div>

      <div v-if="!userIsLoggedIn">
        <router-link to="/login" class="nav-action">
          {{ $t('navbar.actions.login') }}
        </router-link>
        <router-link to="/signup" class="nav-action">
          {{ $t('navbar.actions.signup') }}
        </router-link>
      </div>

      <div v-else>
        <router-link
          class="link-user"
          :to="`/people/${currentUser.id}`"
        >
          <img
            class="image-user"
            :src="currentUser.image"
            :alt="$t('general.user.avatar')"
          >
          {{ currentUser.name }}
        </router-link>
        <router-link to="/" class="nav-action" @click="logout">
          {{ $t('navbar.actions.logout') }}
        </router-link>
      </div>

      <SocialMediaLink
        href="https://twitter.com/adacraft_org"
        :title="$t('social.twitter')"
      >
        <img src="../assets/twitter.svg" alt="adacraft logo" width="18">
      </SocialMediaLink>

      <SocialMediaLink
        href="https://www.instagram.com/adacraft_org"
        :title="$t('social.instagram')"
      >
        <img src="../assets/instagram.svg" alt="adacraft logo" width="16">
      </SocialMediaLink>

      <SocialMediaLink
        href="https://www.facebook.com/adacraft.org"
        :title="$t('social.facebook')"
      >
        <img src="../assets/facebook.svg" alt="adacraft logo" width="16">
      </SocialMediaLink>

      <LanguageSelection :aria-label="$t('navbar.languageSelection.ariaLabel')" />

    </div>

  </nav>
</template>

<script>
import { useSession } from '../store.js'
import { useDark, useToggle } from '@vueuse/core'

import SocialMediaLink from './SocialMediaLink.vue'
import LanguageSelection from './LanguageSelection.vue'

export default {
  name: 'TheNavBar',
  components: {
    SocialMediaLink,
    LanguageSelection
  },
  computed:{
    isProductionEnvironment(){
      return (
        window.location.origin === 'https://adacraft.org'
        || window.location.origin === 'https://www.adacraft.org'
      )
    },
    isBetaEnvironment () {
      return window.location.origin.includes('beta')
    }
  },
  setup () {
    const { currentUser, logout, userIsLoggedIn, feedbackUrl } = useSession()

    // Darkmode
    const isDark = useDark()
    const toggleDark = useToggle(isDark)

    return {
      currentUser,
      logout,
      userIsLoggedIn,
      feedbackUrl,
      isDark,
      toggleDark
    }
  }
}
</script>

<style lang="postcss" scoped>
.main {
  @apply p-6;
  @apply bg-white;
  @apply dark:bg-gray-800;
  @apply border-b border-gray-200;
  @apply dark:border-gray-600;
  @apply flex flex-wrap items-center justify-between;
  @apply fixed top-0 left-0 right-0 z-10;
  
}

.not-prod-env {
  @apply px-3 py-1 mr-10;
  @apply bg-red-400;
  @apply rounded-md;
  @apply text-white font-bold;
}

.app-logo-and-name {
  @apply mr-6;
  @apply flex flex-shrink-0 items-center;
}

.app-name {
  @apply ml-8;
  @apply font-ada;
  @apply font-semibold text-xl tracking-wider;
  @apply dark:text-gray-300;
}

.nav-actions {
  @apply w-full;
  @apply block;
  @apply flex-grow;
}

@screen md {
  .nav-actions {
    @apply flex items-center;
    @apply w-auto;
  }
}

.nav-action {
  @apply mt-4 mx-4;
  @apply block;
  @apply text-gray-600;
  @apply dark:text-gray-400;
}

.nav-action:hover {
  @apply text-black;
  @apply dark:text-gray-300;
}

@screen md {
  .nav-action {
    @apply inline-block;
    @apply mt-0;
  }
}

.darkmode-button {
  @apply py-1 px-4;
  @apply text-white text-xs font-bold;
  @apply dark:text-purple-400;
  @apply bg-purple-400;
  @apply dark:bg-gray-800;
  @apply border rounded shadow;
  @apply dark:border-gray-700 dark:shadow-gray-700;
}

.darkmode-button:hover {
  @apply bg-purple-500;
  @apply dark:bg-gray-700;
}

.link-user {
  @apply mr-4;
  @apply font-semibold text-xl;
  @apply dark:text-gray-300;
}

.image-user {
  @apply mr-2 w-12 h-12;
  @apply inline-block;
  @apply object-contain;
}
</style>